How to Auto Save Document in TypeScript DOCX Editor

28 Aug 20267 minutes to read

In this article, we are going to see how to auto save the document in AWS S3. You can automatically save the edited content in regular intervals of time. It helps reduce the risk of data loss by saving an open document automatically at customizable intervals.

The following example illustrates how to auto save the document in AWS S3.

  • On the client side, using the content change event, we can automatically save the edited content in regular intervals of time. Based on the contentChanged boolean value, the document is sent as DOCX format to the server side using the saveAsBlob method.
import {
    DocumentEditorContainer,
    Toolbar,
} from '@syncfusion/ej2-documenteditor';
let container: DocumentEditorContainer = new DocumentEditorContainer({ enableToolbar: true, height: '590px' });
let contentChanged: boolean = false;
DocumentEditorContainer.Inject(Toolbar);
container.serviceUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
container.created = function () {
    setInterval(() => {
        if (contentChanged) {
            //You can save the document as below
            container.documentEditor.saveAsBlob('Docx').then((blob: Blob) => {
                console.log('Saved successfully');
                let exportedDocument: Blob = blob;
                //Now, save the document wherever you want.
                let formData: FormData = new FormData();
                formData.append('fileName', 'sample.docx');
                formData.append('data', exportedDocument);
                /* tslint:disable */
                let req = new XMLHttpRequest();
                // Replace your running URL here
                req.open(
                    'POST',
                    'http://localhost:62869/api/documenteditor/SaveToS3',
                    true
                );
                req.onreadystatechange = () => {
                    if (req.readyState === 4) {
                        if (req.status === 200 || req.status === 304) {
                            console.log('Saved successfully');
                        }
                    }
                };
                req.send(formData);
            });
            contentChanged = false;
        }
    }, 1000);
};
container.appendTo('#container');

container.contentChange = (): void => {
    contentChanged = true;
};

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

  • On the server side, configure the access key and secret key in the web.config file and register the profile in startup.cs.

In web.config, add the keys in the format below:

 <appSettings>
    <add key="AWSProfileName" value="sync_development" />
    <add key="AWSAccessKey" value="" />
    <add key="AWSSecretKey" value="" />
  </appSettings>

In startup.cs, register the profile in the format below:

Amazon.Util.ProfileManager.RegisterProfile("sync_development","", "");
  • On the server side, receive the stream content from the client side and process it to save the document in AWS S3. Add a Web API in the controller file as below to save the document in AWS S3.
[AcceptVerbs("Post")]
[HttpPost]
[EnableCors("AllowAllOrigins")]
[Route("SaveToS3")]
public string SaveToS3()
{
    IFormFile file = HttpContext.Request.Form.Files[0];
    Stream stream = new MemoryStream();
    file.CopyTo(stream);
    UploadFileStreamToS3(stream, "documenteditor", "", "GettingStarted.docx");
    stream.Close();
    return "Success";
}

public bool UploadFileStreamToS3(System.IO.Stream localFilePath, string bucketName, string subDirectoryInBucket, string fileNameInS3)
{
    AWSCredentials credentials = new StoredProfileAWSCredentials("sync_development");
    IAmazonS3 client = new AmazonS3Client(credentials, Amazon.RegionEndpoint.USEast1);
    TransferUtility utility = new TransferUtility(client);
    TransferUtilityUploadRequest request = new TransferUtilityUploadRequest();

    if (subDirectoryInBucket == "" || subDirectoryInBucket == null)
    {
      request.BucketName = bucketName; //no subdirectory just bucket name  
    }
    else
    {   // subdirectory and bucket name  
      request.BucketName = bucketName + @"/" + subDirectoryInBucket;
    }
    request.Key = fileNameInS3; //file name up in S3  
    request.InputStream = localFilePath;
    utility.Upload(request); //commencing the transfer  

    return true; //indicate that the file was sent  
}

Get the complete working sample here.

How to Auto Save Document in React DOCX Editor

27 Aug 20266 minutes to read

In this article, we are going to see how to auto save the document in AWS S3. You can automatically save the edited content at regular intervals of time. It helps reduce the risk of data loss by saving an open document automatically at customized intervals.

The following example illustrates how to auto save the document in AWS S3.

  • In the client-side, using the content change event, we can automatically save the edited content at regular intervals of time. Based on the contentChanged boolean, the document is sent as DOCX format to the server-side using the saveAsBlob method.

         import * as ReactDOM from 'react-dom';
         import * as React from 'react';
         import { DocumentEditorContainerComponent,
         Toolbar,
      }  from '@syncfusion/ej2-react-documenteditor';
    
    DocumentEditorContainerComponent.Inject(Toolbar);
    function App() {
    let container: DocumentEditorContainerComponent;
    let contentChanged: boolean = false;
    React.useEffect(() => {
      onCreate()
      onContentChange()
    }, []);
    function onCreate() {
      setInterval(() => {
        if (contentChanged) {
          //You can save the document as below
          container.documentEditor.saveAsBlob('Docx').then((blob: Blob) => {
            console.log('Saved successfully');
            let exportedDocument: Blob = blob;
            //Now, save the document where ever you want.
            let formData: FormData = new FormData();
            formData.append('fileName', 'sample.docx');
            formData.append('data', exportedDocument);
            /* tslint:disable */
            var req = new XMLHttpRequest();
            // Replace your running Url here
            req.open(
              'POST',
              'http://localhost:62869/api/documenteditor/SaveToS3',
              true
            );
            req.onreadystatechange = () => {
              if (req.readyState === 4) {
                if (req.status === 200 || req.status === 304) {
                  console.log('Saved successfully');
                }
              }
            };
            req.send(formData);
          });
          contentChanged = false;
        }
      }, 1000);
    }
    
    function onContentChange() {
      contentChanged = true;
    }
    return (
      <DocumentEditorContainerComponent
        id="container"
        ref={(scope) => {
          container = scope;
        }}
        height={'590px'}
        serviceUrl="https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/"
        enableToolbar={true} created={onCreate} contentChange={onContentChange}
      />
     );
    }
    export default App;
    ReactDOM.render(<App />, document.getElementById('sample'));

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

  • In the server-side, configure the access key and secret key in the web.config file and register the profile in startup.cs.

    In web.config, add a key in the following format:

     <appSettings>
      <add key="AWSProfileName" value="sync_development" />
      <add key="AWSAccessKey" value="" />
      <add key="AWSSecretKey" value="" />
     </appSettings>

In startup.cs, register the profile in the following format:

   Amazon.Util.ProfileManager.RegisterProfile("sync_development","", "");
  • In the server-side, receive the stream content from the client-side and process it to save the document in AWS S3. Add a Web API in the controller file like below to save the document in AWS S3.

    [AcceptVerbs("Post")]
    [HttpPost]
    [EnableCors("AllowAllOrigins")]
    [Route("SaveToS3")]
     public string SaveToS3()
    {
      IFormFile file = HttpContext.Request.Form.Files[0];
      Stream stream = new MemoryStream();
      file.CopyTo(stream);
      UploadFileStreamToS3(stream, "documenteditor", "", "GettingStarted.docx");
      stream.Close();
      return "Sucess";
    }
    
    public bool UploadFileStreamToS3(System.IO.Stream localFilePath, string bucketName, string subDirectoryInBucket, string fileNameInS3)
    {
      AWSCredentials credentials = new StoredProfileAWSCredentials("sync_development");
      IAmazonS3 client = new AmazonS3Client(credentials, Amazon.RegionEndpoint.USEast1);
      TransferUtility utility = new TransferUtility(client);
      TransferUtilityUploadRequest request = new TransferUtilityUploadRequest();
    
      if (subDirectoryInBucket == "" || subDirectoryInBucket == null)
      {
        request.BucketName = bucketName; //no subdirectory just bucket name  
      }
      else
      {   // subdirectory and bucket name  
        request.BucketName = bucketName + @"/" + subDirectoryInBucket;
      }
      request.Key = fileNameInS3; //file name up in S3  
      request.InputStream = localFilePath;
      utility.Upload(request); //commencing the transfer
    
      return true; //indicate that the file was sent  
    }

Get the complete working sample in this link.

How to Auto Save Document in Angular DOCX Editor

27 Aug 20268 minutes to read

In this article, we are going to see how to auto save the document in AWS S3. You can automatically save the edited content at regular intervals of time. It helps reduce the risk of data loss by saving an open document automatically at customized intervals.

The following example illustrates how to auto save the document in AWS S3.

  • In the client-side, using the content change event, we can automatically save the edited content at regular intervals of time. Based on the contentChanged boolean, the document is sent as DOCX format to the server-side using the saveAsBlob method.
/**
 * Add below codes in app.component.html file
 */
 <ejs-documenteditorcontainer #documenteditor_default [enableToolbar]="true" (created)="onCreate()"
                (contentChange)="onContentChange()" height="600px" style="display:block;"></ejs-documenteditorcontainer>

/**
 * Add below codes in app.component.ts file
 */
@Component({
      selector: 'app-root',
      templateUrl: 'app.component.html',
      encapsulation: ViewEncapsulation.None,
      providers: [ToolbarService]
})
export class AppComponent {

    @ViewChild('documenteditor_default')
    public container: DocumentEditorContainerComponent;
    contentChanged: boolean;

      onCreate(): void {
          this.container.serviceUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';

          setInterval(() => {
              if (this.contentChanged) {
                  // Save the document as shown below.
                  this.container.documentEditor.saveAsBlob('Docx').then((blob: Blob) => {
                      console.log('Saved successfully');
                      let exportedDocument: Blob = blob;
                      // Save the document wherever you want.
                      let formData: FormData = new FormData();
                      formData.append('fileName', 'sample.docx');
                      formData.append('data', exportedDocument);
                      /* tslint:disable */
                      var req = new XMLHttpRequest();
                      // Replace with your running URL here.
                      req.open(
                        'POST',
                        'http://localhost:62869/api/documenteditor/SaveToS3',
                        true
                      );
                      req.onreadystatechange = () => {
                        if (req.readyState === 4) {
                          if (req.status === 200 || req.status === 304) {
                            console.log('Saved successfully');
                          }
                        }
                      };
                      req.send(formData);
                    });
                    this.contentChanged = false;
                  }
                }, 1000);
      }

      onContentChange(): void {
          this.contentChanged = true;
      }
}

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

  • In the server-side, configure the access key and secret key in the web.config file and register the profile in startup.cs.

In web.config, add a key in the following format:

 <appSettings>
    <add key="AWSProfileName" value="sync_development" />
    <add key="AWSAccessKey" value="" />
    <add key="AWSSecretKey" value="" />
  </appSettings>

In startup.cs, register the profile in the following format:

Amazon.Util.ProfileManager.RegisterProfile("sync_development","", "");
  • In the server-side, receive the stream content from the client-side and process it to save the document in AWS S3. Add a Web API in the controller file like below to save the document in AWS S3.
[AcceptVerbs("Post")]
[HttpPost]
[EnableCors("AllowAllOrigins")]
[Route("SaveToS3")]
public string SaveToS3()
{
    IFormFile file = HttpContext.Request.Form.Files[0];
    Stream stream = new MemoryStream();
    file.CopyTo(stream);
    UploadFileStreamToS3(stream, "documenteditor", "", "GettingStarted.docx");
    stream.Close();
    return "Sucess";
}

public bool UploadFileStreamToS3(System.IO.Stream localFilePath, string bucketName, string subDirectoryInBucket, string fileNameInS3)
{
    AWSCredentials credentials = new StoredProfileAWSCredentials("sync_development");
    IAmazonS3 client = new AmazonS3Client(credentials, Amazon.RegionEndpoint.USEast1);
    TransferUtility utility = new TransferUtility(client);
    TransferUtilityUploadRequest request = new TransferUtilityUploadRequest();

    if (subDirectoryInBucket == "" || subDirectoryInBucket == null)
    {
request.BucketName = bucketName; //no subdirectory just bucket name  
    }
    else
    {   // subdirectory and bucket name  
request.BucketName = bucketName + @"/" + subDirectoryInBucket;
    }
    request.Key = fileNameInS3; //file name up in S3  
    request.InputStream = localFilePath;
    utility.Upload(request); //commensing the transfer  

    return true; //indicate that the file was sent  
}

Get the complete working sample in this link.

How to Auto Save Document in Vue DOCX Editor

28 Aug 202611 minutes to read

In this article, we are going to see how to auto save the document in AWS S3. You can automatically save the edited content in regular intervals of time. It helps reduce the risk of data loss by saving an open document automatically at customized intervals.

The following example illustrates how to auto save the document in AWS S3.

  • In the client-side, using the content change event, we can automatically save the edited content in regular intervals of time. Based on the contentChanged boolean value, the document is sent as a DOCX file to the server-side using the saveAsBlob method.
<template>
  <div id="app">
    <ejs-documenteditorcontainer ref='container' :serviceUrl='serviceUrl' v-on:created="onCreated"
      v-on:contentChange="contentChangeEvent" height="590px" id='container'
      :enableToolbar='true'></ejs-documenteditorcontainer>
  </div>
</template>
<script setup>
import { DocumentEditorContainerComponent as EjsDocumenteditorcontainer, Toolbar } from '@syncfusion/ej2-vue-documenteditor';
import { provide, ref } from 'vue';

const container = ref(null);
const serviceUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
const contentChanged = ref(false);

//Inject required modules.
provide('DocumentEditorContainer', [Toolbar]);

const contentChangeEvent = function () {
  contentChanged.value = true;
}
const onCreated = function () {
  setInterval(() => {
    if (contentChanged.value) {
      //You can save the document as below
      container.value.ej2Instances.documentEditor
        .saveAsBlob('Docx')
        .then((blob) => {
          console.log('Saved successfully');
          let exportedDocument = blob;
          //Now, save the document wherever you want.
          let formData = new FormData();
          formData.append('fileName', 'sample.docx');
          formData.append('data', exportedDocument);
          /* tslint:disable */
          var req = new XMLHttpRequest();
          // Replace your running Url here
          req.open(
            'POST',
            'http://localhost:62869/api/documenteditor/SaveToS3',
            true
          );
          req.onreadystatechange = () => {
            if (req.readyState === 4) {
              if (req.status === 200 || req.status === 304) {
                console.log('Saved successfully');
              }
            }
          };
          req.send(formData);
        });
      contentChanged.value = false;
    }
  }, 1000);
}
</script>
<template>
  <div id="app">
    <ejs-documenteditorcontainer ref='container' :serviceUrl='serviceUrl' v-on:created="onCreated"
      v-on:contentChange="contentChangeEvent" height="590px" id='container'
      :enableToolbar='true'></ejs-documenteditorcontainer>
  </div>
</template>
<script>
import { DocumentEditorContainerComponent, Toolbar } from '@syncfusion/ej2-vue-documenteditor';

export default {
  components: {
    'ejs-documenteditorcontainer': DocumentEditorContainerComponent
  },
  data() {
    return {
      serviceUrl: 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/',
      contentChanged: false
    };
  },
  provide: {
    //Inject required modules.
    DocumentEditorContainer: [Toolbar]
  },
  methods: {
    contentChangeEvent: function () {
      this.contentChanged = true;
    },
    onCreated: function () {
      setInterval(() => {
        if (this.contentChanged) {
          //You can save the document as below
          this.$refs.container.ej2Instances.documentEditor
            .saveAsBlob('Docx')
            .then((blob) => {
              console.log('Saved successfully');
              let exportedDocument = blob;
              //Now, save the document wherever you want.
              let formData = new FormData();
              formData.append('fileName', 'sample.docx');
              formData.append('data', exportedDocument);
              /* tslint:disable */
              var req = new XMLHttpRequest();
              // Replace your running Url here
              req.open(
                'POST',
                'http://localhost:62869/api/documenteditor/SaveToS3',
                true
              );
              req.onreadystatechange = () => {
                if (req.readyState === 4) {
                  if (req.status === 200 || req.status === 304) {
                    console.log('Saved successfully');
                  }
                }
              };
              req.send(formData);
            });
          this.contentChanged = false;
        }
      }, 1000);
    },
  },
};
</script>

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

  • In the server-side, configure the access key and secret key in the web.config file and register the profile in startup.cs.

    In `web.config`, add keys in the format below:
    
    ```c#
    <appSettings>
        <add key="AWSProfileName" value="sync_development" />
        <add key="AWSAccessKey" value="" />
        <add key="AWSSecretKey" value="" />
      </appSettings>
    ```
    
    In `startup.cs`, register the profile in the format below:
    
    ```c#
    Amazon.Util.ProfileManager.RegisterProfile("sync_development","", "");
    ```
    
    • In the server-side, receive the stream content from the client-side and process it to save the document in an AWS S3. Add a Web API in the controller file like below to save the document in an AWS S3.

        [AcceptVerbs("Post")]
        [HttpPost]
        [EnableCors("AllowAllOrigins")]
        [Route("SaveToS3")]
        public string SaveToS3()
        {
            IFormFile file = HttpContext.Request.Form.Files[0];
            Stream stream = new MemoryStream();
            file.CopyTo(stream);
            UploadFileStreamToS3(stream, "documenteditor", "", "GettingStarted.docx");
            stream.Close();
            return "Success";
        }
      
        public bool UploadFileStreamToS3(System.IO.Stream localFilePath, string bucketName, string subDirectoryInBucket, string fileNameInS3)
        {
            AWSCredentials credentials = new StoredProfileAWSCredentials("sync_development");
            IAmazonS3 client = new AmazonS3Client(credentials, Amazon.RegionEndpoint.USEast1);
            TransferUtility utility = new TransferUtility(client);
            TransferUtilityUploadRequest request = new TransferUtilityUploadRequest();
      
            if (subDirectoryInBucket == "" || subDirectoryInBucket == null)
            {
        request.BucketName = bucketName; //no subdirectory just bucket name
            }
            else
            {   // subdirectory and bucket name
        request.BucketName = bucketName + @"/" + subDirectoryInBucket;
            }
            request.Key = fileNameInS3; //file name up in S3
            request.InputStream = localFilePath;
            utility.Upload(request); //commencing the transfer
      
            return true; //indicate that the file was sent  
        }

Get the complete working sample in this link.